#ifndef __BLDC_APP_H_
#define __BLDC_APP_H_

/*********************************Header File********************************************************/
#include "mlib.h"
#include "mlib_types.h"
#include "gflib.h"
/*********************************Header File********************************************************/

/*********************************Variable Declaration*************************************/
extern uint8_t                    appState;
extern uint8_t                    ui8AppStartFlag;
extern frac16_t                   f16TargetSpeed;
extern frac16_t                   f16TargetSpeedRamped;
extern GFLIB_RAMP_T_F16           sSpeedRampParam;
extern frac16_t                   f16CaptureSpeed;
extern frac16_t                   f16SpeedCoef;
extern volatile uint32_t          speed_limit_monitor;
extern volatile frac16_t          f16Idcb;
extern GFLIB_CTRL_PI_P_AW_T_A32   sSpeedCtrl;
extern volatile frac16_t          f16Vdcb;
extern frac16_t                   f16IdcbHighLimit;
extern frac16_t                   f16IdcbLowLimit;
extern uint8_t                    s_Mdirection;
/*********************************Variable Declaration*************************************/

/*********************************Function Declaration*************************************/
/*****************************************************************************
+FUNCTION----------------------------------------------------------------
* @function name: BLDC_AppStateMachineInit
*
* @brief  initialize app state machine
*        
* @param  none
*
* @return none
*
* @ Pass/ Fail criteria: none
*****************************************************************************/
void BLDC_AppStateMachineInit(void);
/*********************************Function Declaration*************************************/

#endif